﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using System.Threading;
using Microsoft.DirectX;
using Microsoft.DirectX.DirectSound;
using SoundStream;
using System.IO;
using System.Collections;



namespace cw_tool
{
    public partial class Worker_view : Form
    {
        Voice voice;
        Reccognition reco;
        private Thread thread_send=null;

        public byte ticks;
        public byte ticks_p;
        public byte precision = 10;

        private int send_speed ;
        private int pause;
        private char [] toSend;        

        // **********************************************************************************
        public Worker_view()
        {
            InitializeComponent();
            voice = new Voice(this);
            reco = new Reccognition(this);

            this.trackBar_Volume.Maximum = 30000;
            this.trackBar_Volume.Minimum = 1000;
            this.trackBar_Volume.Value = 9000;
            this.trackBar_Volume.TickFrequency = 2000;

            this.label_volume.Text = "Volume: " + (this.trackBar_Volume.Value * 100) / 30000 +" %";

            this.trackBar_Frequenz.Maximum = 2000;
            this.trackBar_Frequenz.Minimum = 100;
            this.trackBar_Frequenz.Value = 700;
            this.trackBar_Frequenz.TickFrequency = 100;

            this.label_frequenz.Text = "Frequenz: " + this.trackBar_Frequenz.Value.ToString() + " Hz";

            this.voice.init((float)this.trackBar_Frequenz.Value, this.trackBar_Volume.Value);

            this.send_speed = this.trackBar_sendSpeed.Value;
            this.label_sendSpeed.Text = "Speed: " + this.send_speed.ToString();

            this.pause = this.trackBar_pause.Value;
            this.label_pause.Text = "Pause: "+this.pause.ToString();

            this.toolTip_picBox.SetToolTip(this.picBox_morsetaste, "Klicken um Sound zu spielen !");
            
            string line = "";
            try
            {
                StreamReader reader = new StreamReader(Path.GetDirectoryName(System.Reflection.Assembly.GetExecutingAssembly().Location)+@"LastTextFile.txt");
                while ((line = reader.ReadLine()) != null)
                {
                    this.richTextBox_Data.AppendText(line.ToUpper());
                }
                reader.Close();
            }
            catch (Exception ex)
            {
                //MessageBox.Show(ex.ToString());
            }

        }


        // **********************************************************************************
        private void picBox_morsetaste_MouseDown(object sender, MouseEventArgs e)
        {
            this.voice.start();

            this.timer_recognition.Start();
            this.timer_pause.Stop();
        }
        
        
        // **********************************************************************************
        private void picBox_morsetaste_MouseUp(object sender, MouseEventArgs e)
        {
            this.voice.stop();

            this.timer_recognition.Stop();

            this.reco.saveLetter();

            this.ticks = 0;

            this.ticks_p = 0;
            this.timer_pause.Start();

            this.label_letter.Text = "Buchstabe: ";
        }
        
        
        // **********************************************************************************
        private void trackBar_Volume_MouseUp(object sender, MouseEventArgs e)
        {
            float freq = (float)this.trackBar_Frequenz.Value;
            this.voice.init(freq, this.trackBar_Volume.Value);
            this.label_volume.Text = "Volume: " + (this.trackBar_Volume.Value * 100) / 30000 + " %";
        }
        
        
        // **********************************************************************************
        private void trackBar_Volume_MouseHover(object sender, EventArgs e)
        {
            this.trackBar_Volume.Select();
        }
        
        
        // **********************************************************************************
        private void trackBar_Frequenz_MouseHover(object sender, EventArgs e)
        {
            this.trackBar_Frequenz.Select();
        }
        
        
        // **********************************************************************************
        private void trackBar_Frequenz_MouseUp(object sender, MouseEventArgs e)
        {
            float freq = (float)this.trackBar_Frequenz.Value;
            this.voice.init(freq, this.trackBar_Volume.Value);
            this.label_frequenz.Text = "Frequenz: " + this.trackBar_Frequenz.Value.ToString()+" Hz";
        }


        // **********************************************************************************
        private void timer_recognition_Tick(object sender, EventArgs e)
        {
            if(ticks<100)ticks++;
        }


        // **********************************************************************************
        private void timer_pause_Tick(object sender, EventArgs e)
        {

            if (ticks_p < 100)
            {
                ticks_p++;
            }
            if (ticks_p > this.pause)
            {
                Letter l = this.reco.checkPause();
                if (l != null)
                {
                    this.label_letter.Text = "Buchstabe:   " + l.buchstabe + "    (" + l.sound + ")";
                    if(this.checkBox_saveLetter.Checked==true)this.richTextBox_Data.AppendText(l.buchstabe);
                }
            }
        }

        
        // **********************************************************************************
        private void richrichTextBox_Data_TextChanged(object sender, EventArgs e)
        {/*
            string s = this.richrichTextBox_Data.Text;            
            this.richrichTextBox_Data.Text= s.ToUpper();
            this.richTextBox_Data.AppendText(" ");
          */ 
            
        }
   
        
        // **********************************************************************************
        private void button_load_Click(object sender, EventArgs e)
        {
            OpenFileDialog fileDialog = new OpenFileDialog();          // datei öfnen dialog                     
            
            fileDialog.Title = "Datei wählen";
            fileDialog.Filter = "Text file (*.txt)|*.txt";

            if (fileDialog.ShowDialog() == DialogResult.OK)            // dialog zum datei öffnen
            {
                readFile(fileDialog.FileName);
            }
        }
    
        
        // **********************************************************************************
        private void richrichTextBox_Data_DragDrop(object sender, DragEventArgs e)
        {
            string fileName = ((string[])e.Data.GetData(DataFormats.FileDrop))[0];
            this.readFile(fileName);           
        }
   
        
        // **********************************************************************************
        private void richrichTextBox_Data_DragEnter(object sender, DragEventArgs e)
        {
            if (e.Data.GetDataPresent(DataFormats.FileDrop, false))
            {
                e.Effect = DragDropEffects.All;
            }
        }


        // **********************************************************************************
        private void readFile(string fileName)
        {
            String line = "";
            this.richTextBox_Data.Clear();
            try
            {
                StreamReader reader = new StreamReader(fileName);
                while ((line = reader.ReadLine()) != null)
                {
                    this.richTextBox_Data.AppendText(line.ToUpper());
                }
                reader.Close();
            }
            catch (Exception ex)
            {
                MessageBox.Show(ex.ToString());
            }
        }
        
        
        // **********************************************************************************
        private void button_clear_Click(object sender, EventArgs e)
        {
            this.richTextBox_Data.Clear();
        }
        
        
        // **********************************************************************************
        private void button_send_Click(object sender, EventArgs e)
        {
            if (this.button_send.Text == "Stop")
            {
                this.thread_send.Abort();
                this.voice.stop();                
                this.button_send.Text = "Play";
                this.richTextBox_Data.Enabled = true;
                this.richTextBox_Data.Select(0, this.richTextBox_Data.Text.Length);
                this.richTextBox_Data.SelectionColor = Color.Black;
            }
            else if (this.richTextBox_Data.Text != "")
            {                
                this.toSend = this.richTextBox_Data.Text.ToCharArray();                
                this.richTextBox_Data.Enabled = false;
                this.richTextBox_Data.Select(0, this.richTextBox_Data.Text.Length);
                this.richTextBox_Data.SelectionColor = Color.Black;
                this.thread_send = new Thread(new ThreadStart(this.sendLetters));                
                this.thread_send.Start();
                this.button_send.Text = "Stop";                
            }
            

        }


        // **********************************************************************************
        private void sendLetters()
        {
            ArrayList letters = this.reco.getLetters();
            int i;

            do
            {
                i = 0;
                do
                {                    // zum vergleichen der gespeicherten buchstaben mit den zu sendenden
                    for (int j = 0; j < letters.Count; j++)
                    {
                        // buchstabe erkannt
                        if (((Letter)letters[j]).buchstabe == (this.toSend[i].ToString()).ToUpper())
                        {
                            this.setLabelBuchstabe(((Letter)letters[j]).buchstabe, "    (" + ((Letter)letters[j]).sound + ")");
                            this.setRichTextBox_Data_Color(i,Color.Red);
                            
                            int z = 0;
                            // hier werden die buchstaben-codes wirklich in töne gewandelt ( ein kompletter buchstabe)
                            do
                            {
                                this.voice.start();
                                if (((Letter)letters[j]).code[z] == 75) Thread.Sleep(this.send_speed);
                                if (((Letter)letters[j]).code[z] == 225) Thread.Sleep(this.send_speed * 3);
                                this.voice.stop();
                                Thread.Sleep(this.send_speed);
                                z++;
                            } while (z < ((Letter)letters[j]).code.Length);
                            this.setLabelBuchstabe("", "");                            
                            Thread.Sleep(this.pause/10 * this.send_speed);
                            this.setRichTextBox_Data_Color(i, Color.Black);
                        }
                    }
                    i++;
                } while (i < toSend.Length);
            } while (this.checkBox_repeat.Checked == true);
            this.resetRichTextBox_Data_Color();
        }


        // **********************************************************************************
        private void setRichTextBox_Data_Color(int index,Color c)
        {
            if (this.richTextBox_Data.InvokeRequired)
            {
                this.Invoke(new MethodInvoker(delegate() { setRichTextBox_Data_Color(index,c); }));
            }
            else
            {
                this.richTextBox_Data.Select(index, 1);
                this.richTextBox_Data.SelectionColor = c;                
            }
        }


        // **********************************************************************************
        private void resetRichTextBox_Data_Color()
        {
            if (this.richTextBox_Data.InvokeRequired)
            {
                this.Invoke(new MethodInvoker(delegate() { resetRichTextBox_Data_Color(); }));
            }
            else
            {
                this.richTextBox_Data.Select(0, this.richTextBox_Data.Text.Length);
                this.richTextBox_Data.SelectionColor = Color.Black;
                this.richTextBox_Data.Enabled = true;
                this.button_send.Text = "Play";
            }
        }


        // **********************************************************************************
        private void setLabelBuchstabe(string buchstabe,string sound)
        {
            if (this.label_letter.InvokeRequired)
            {
                this.Invoke(new MethodInvoker(delegate() { setLabelBuchstabe(buchstabe,sound); }));
            }
            else
            {
                this.label_letter.Text = "Buchstabe:   " + buchstabe +  sound ;
            }
        }

        
        // **********************************************************************************
        private void trackBar_sendSpeed_MouseUp(object sender, MouseEventArgs e)
        {
            this.send_speed = this.trackBar_sendSpeed.Value;
            this.label_sendSpeed.Text = "Speed: " + this.send_speed.ToString();
        }
        
        
        // **********************************************************************************
        private void Worker_view_FormClosed(object sender, FormClosedEventArgs e)
        {
            if(this.thread_send!=null)this.thread_send.Abort();
        }

        
        // **********************************************************************************
        private void trackBar_pause_MouseUp(object sender, MouseEventArgs e)
        {
            this.pause = this.trackBar_pause.Value;
            this.label_pause.Text = "Pause: " + this.pause.ToString();
        }


        // **********************************************************************************
        private void button_info_Click(object sender, EventArgs e)
        {
            InfoForm myInfo = new InfoForm();
            myInfo.Show();
        }

        
        // **********************************************************************************
        private void Worker_view_FormClosing(object sender, FormClosingEventArgs e)
        {
            string appPath = Path.GetDirectoryName(System.Reflection.Assembly.GetExecutingAssembly().Location);            
            StreamWriter myFile = new StreamWriter(appPath + @"LastTextFile.txt");
            myFile.Write(this.richTextBox_Data.Text);
            myFile.Close();
        }

       
    }
}
